<script setup lang="ts">
import { useMemberStore } from '@/stores/MemberStore';
import { useReceipStore } from '@/stores/receipt';
import { ref } from 'vue';
const divreceipItems = ref<HTMLLIElement | null>(null)
const memberStore = useMemberStore();
const receiptStore = useReceipStore();
const formatDate = (dateString: any): string => {
    if (!dateString) return '';

    const options: Intl.DateTimeFormatOptions = {
        year: 'numeric',
        month: 'numeric',
        day: 'numeric',
        hour: 'numeric',
        minute: 'numeric',
    };

    const formattedDate = new Date(dateString).toLocaleString('en-US', options);

    return formattedDate;
};
const handleCashClick = () => {
    receiptStore.setPaymentType('cash');
    receiptStore.receipt.receivedAmount = 0
};

const handleQRCodeClick = () => {
    receiptStore.setPaymentType('qrcode');
};
</script>
<template>
    <v-dialog v-model="receiptStore.receiptDialog" persistent width="auto">
        <v-card style="background-color: #FCE4EC">
            <v-card-title class="text-h5 text-center">
                Repeat
                <v-sheet width="200" height="200" elevation="3" cover
                    style="margin-left:auto;margin-right: auto;margin-top: 5%;">
                    <v-img src="src\assets\POS\cafe.png" height="200" style="background-color: #FCE4EC"></v-img>
                </v-sheet>
            </v-card-title>

            <v-card-text>
                <v-container>
                    <table>
                        <th>
                            <v-row no-gutters style="margin-left:10%;margin-right: auto; text-align: left;">
                                <v-divider></v-divider>
                                <v-col cols="6">Date</v-col><v-col cols="6">{{
                                    formatDate(receiptStore.receipt?.createdDate)
                                }}</v-col>
                                <v-col cols="6">Member</v-col><v-col cols="6">{{ memberStore.currentMember?.name }}</v-col>
                                <v-col cols="12">
                                    <v-divider></v-divider>
                                    <v-row>
                                        <v-col cols="4" style="margin-left: 5%;"><strong>Name</strong></v-col>
                                        <v-col cols="2"><strong>Quantity</strong></v-col>
                                        <v-col cols="2" style="margin-left: 5%;"><strong>Price</strong></v-col>
                                    </v-row>
                                    <v-row v-for="item in receiptStore.receiptItems" :key="item.productsId">
                                        <v-col cols="4" style="margin-left: 5%;">{{ item.name }}</v-col>
                                        <v-col cols="2">{{ item.unit }}</v-col>
                                        <v-col cols="2" style="margin-left: 5%;">{{ item.price }}</v-col>
                                    </v-row>
                                </v-col>
                                <v-divider></v-divider>
                                <v-col cols="6">TotalBefore</v-col><v-col cols="6">{{ receiptStore.receipt?.total }}</v-col>
                                <v-col cols="6">MemberDiscount</v-col><v-col cols="6">{{
                                    receiptStore.receipt?.memberDiscount
                                }}</v-col>
                                <v-col cols="6">Total</v-col><v-col cols="6">{{ receiptStore.receipt?.totalBefore
                                }}</v-col>
                                <v-divider></v-divider>
                            </v-row>
                        </th>
                        <th>
                            <v-card-title class="text-h5 text-center">
                                Payment Type
                            </v-card-title>
                            <v-card-text>
                                <v-row style="text-align: center;">
                                    <v-col>
                                        <v-sheet width="180" height="100" elevation="3" @click="handleCashClick"
                                            style="background-color: #ffd4e2">
                                            Cash
                                            <v-img src="src\assets\POS\money.png" height="70"></v-img>
                                        </v-sheet>
                                    </v-col>
                                    <v-col>
                                        <v-sheet width="170" height="100" elevation="3" @click="handleQRCodeClick"
                                            style="background-color: #ffd4e2">
                                            QRCode
                                            <v-img src="src\assets\POS\qr-code.png" height="70">
                                            </v-img>
                                        </v-sheet>
                                    </v-col>
                                </v-row>
                                <v-col v-if="receiptStore.paymentType === 'cash'">
                                    <v-divider></v-divider>
                                    <v-row>
                                        <v-col cols="6">Total</v-col>
                                        <v-col cols="6">{{ receiptStore.receipt?.total }}</v-col>
                                    </v-row>
                                    <v-row>
                                        <v-col cols="6">Cash</v-col>
                                        <v-col cols="6">
                                            <v-text-field v-model="receiptStore.receipt.receivedAmount" outlined
                                                label="จำนวนเงิน" type="number"></v-text-field>
                                        </v-col>
                                    </v-row>
                                    <v-row>
                                        <v-col cols="6">Change</v-col>
                                        <v-col cols="6">
                                            {{ receiptStore.calculateChange() }}
                                        </v-col>
                                    </v-row>
                                </v-col>
                                <v-col v-if="receiptStore.paymentType === 'qrcode'">
                                    <v-divider></v-divider>
                                    <v-row>
                                        <v-col cols="6">Total</v-col>
                                        <v-col cols="6">{{ receiptStore.receipt?.total }}</v-col>
                                        <v-img src="src\assets\POS\QRcode.jpg" width="150" height="146">
                                        </v-img>
                                    </v-row>
                                </v-col>
                            </v-card-text>
                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="white-darken-1" variant="text" @click="receiptStore.receiptDialog = false"
                                    style="background-color: #ffd4e2;">
                                    Cancel
                                </v-btn>
                                <v-btn color="white-darken-1" variant="text" @click="() => {
                                    receiptStore.hidePaymentTypeDialog()
                                }" style="background-color: #ffd4e2">
                                    Confirm
                                </v-btn>
                            </v-card-actions>
                        </th>
                    </table>

                </v-container>
            </v-card-text>
        </v-card>
    </v-dialog>
    <PaymentTypeDialog></PaymentTypeDialog>
</template>